/*

                        Copyright (c) 1994 by
                        Advanced Visual Systems Inc.
                        All Rights Reserved

        This software comprises unpublished confidential information of
        Advanced Visual Systems Inc. and may not be used, copied or made
        available to anyone, except in accordance with the license
        under which it is furnished.

        This file is under Perforce control
        $Id: //depot/express/fcs992/include/avs/cstring.h#1 $
*/

/*---------------------------------------------------------------------*
 *
 * cstring.h - composite string header file
 *
 *---------------------------------------------------------------------*/

#ifndef CS_H_INCLUDED
#define CS_H_INCLUDED

/*---------------------------------------------------------------------*/

#ifndef MSDOS
#include <Xm/Xm.h>
#endif

#include <avs/port.h>

/*---------------------------------------------------------------------*/
/*                         Datatypes                                   */
/*---------------------------------------------------------------------*/

typedef struct _CSsubstr 
{
   char      *str;      /* null-terminated substring (ASCII or raw JIS) */
   int       bpc;       /* number of bytes-per-character in str: 1 or 2 */
}  CSsubstr;

typedef struct _CScomstr
{
   int       nsubstr;   /* number of substrings */
   CSsubstr  *substr;   /* array of substrings */
}  CScomstr;
   
/*---------------------------------------------------------------------*/
/*                          Function prototypes                        */
/*---------------------------------------------------------------------*/

#ifdef __cplusplus 
extern "C" { 
#endif

CScomstr* CSstr_to_com  PTARGS(( char * ));
char*     CScom_to_str  PTARGS(( CScomstr * )); 
char*     CSstr_to_euc  PTARGS(( char * ));

void      CScom_free    PTARGS(( CScomstr ** ));

#ifndef MSDOS
XmString  CSstr_to_Xm   PTARGS(( char * ));
XmString  CScom_to_Xm   PTARGS(( CScomstr * ));
CScomstr* CSxm_to_com   PTARGS(( XmString ));
char*     CSxm_to_str   PTARGS(( XmString ));
#endif

#ifdef __cplusplus
} 
#endif

/*---------------------------------------------------------------------*/

#endif /* CS_H_INCLUDED */
